// Code generated by protoc-gen-go. DO NOT EDIT.
// source: envoy/config/filter/network/http_connection_manager/v2/http_connection_manager.proto

/*
Package v2 is a generated protocol buffer package.

It is generated from these files:
	envoy/config/filter/network/http_connection_manager/v2/http_connection_manager.proto

It has these top-level messages:
	HttpConnectionManager
	Rds
	HttpFilter
*/
package v2

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import envoy_api_v2_core2 "github.com/cilium/cilium/pkg/envoy/envoy/api/v2/core"
import envoy_api_v2_core3 "github.com/cilium/cilium/pkg/envoy/envoy/api/v2/core"
import envoy_api_v21 "github.com/cilium/cilium/pkg/envoy/envoy/api/v2"
import envoy_config_filter_accesslog_v2 "github.com/cilium/cilium/pkg/envoy/envoy/config/filter/accesslog/v2"
import envoy_type1 "github.com/cilium/cilium/pkg/envoy/envoy/type"
import google_protobuf3 "github.com/golang/protobuf/ptypes/duration"
import google_protobuf "github.com/golang/protobuf/ptypes/struct"
import google_protobuf1 "github.com/golang/protobuf/ptypes/wrappers"
import _ "github.com/lyft/protoc-gen-validate/validate"
import _ "github.com/gogo/protobuf/gogoproto"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type HttpConnectionManager_CodecType int32

const (
	// For every new connection, the connection manager will determine which
	// codec to use. This mode supports both ALPN for TLS listeners as well as
	// protocol inference for plaintext listeners. If ALPN data is available, it
	// is preferred, otherwise protocol inference is used. In almost all cases,
	// this is the right option to choose for this setting.
	HttpConnectionManager_AUTO HttpConnectionManager_CodecType = 0
	// The connection manager will assume that the client is speaking HTTP/1.1.
	HttpConnectionManager_HTTP1 HttpConnectionManager_CodecType = 1
	// The connection manager will assume that the client is speaking HTTP/2
	// (Envoy does not require HTTP/2 to take place over TLS or to use ALPN.
	// Prior knowledge is allowed).
	HttpConnectionManager_HTTP2 HttpConnectionManager_CodecType = 2
)

var HttpConnectionManager_CodecType_name = map[int32]string{
	0: "AUTO",
	1: "HTTP1",
	2: "HTTP2",
}
var HttpConnectionManager_CodecType_value = map[string]int32{
	"AUTO":  0,
	"HTTP1": 1,
	"HTTP2": 2,
}

func (x HttpConnectionManager_CodecType) String() string {
	return proto.EnumName(HttpConnectionManager_CodecType_name, int32(x))
}
func (HttpConnectionManager_CodecType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{0, 0}
}

// How to handle the :ref:`config_http_conn_man_headers_x-forwarded-client-cert` (XFCC) HTTP
// header.
type HttpConnectionManager_ForwardClientCertDetails int32

const (
	// Do not send the XFCC header to the next hop. This is the default value.
	HttpConnectionManager_SANITIZE HttpConnectionManager_ForwardClientCertDetails = 0
	// When the client connection is mTLS (Mutual TLS), forward the XFCC header
	// in the request.
	HttpConnectionManager_FORWARD_ONLY HttpConnectionManager_ForwardClientCertDetails = 1
	// When the client connection is mTLS, append the client certificate
	// information to the request’s XFCC header and forward it.
	HttpConnectionManager_APPEND_FORWARD HttpConnectionManager_ForwardClientCertDetails = 2
	// When the client connection is mTLS, reset the XFCC header with the client
	// certificate information and send it to the next hop.
	HttpConnectionManager_SANITIZE_SET HttpConnectionManager_ForwardClientCertDetails = 3
	// Always forward the XFCC header in the request, regardless of whether the
	// client connection is mTLS.
	HttpConnectionManager_ALWAYS_FORWARD_ONLY HttpConnectionManager_ForwardClientCertDetails = 4
)

var HttpConnectionManager_ForwardClientCertDetails_name = map[int32]string{
	0: "SANITIZE",
	1: "FORWARD_ONLY",
	2: "APPEND_FORWARD",
	3: "SANITIZE_SET",
	4: "ALWAYS_FORWARD_ONLY",
}
var HttpConnectionManager_ForwardClientCertDetails_value = map[string]int32{
	"SANITIZE":            0,
	"FORWARD_ONLY":        1,
	"APPEND_FORWARD":      2,
	"SANITIZE_SET":        3,
	"ALWAYS_FORWARD_ONLY": 4,
}

func (x HttpConnectionManager_ForwardClientCertDetails) String() string {
	return proto.EnumName(HttpConnectionManager_ForwardClientCertDetails_name, int32(x))
}
func (HttpConnectionManager_ForwardClientCertDetails) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{0, 1}
}

type HttpConnectionManager_Tracing_OperationName int32

const (
	// The HTTP listener is used for ingress/incoming requests.
	HttpConnectionManager_Tracing_INGRESS HttpConnectionManager_Tracing_OperationName = 0
	// The HTTP listener is used for egress/outgoing requests.
	HttpConnectionManager_Tracing_EGRESS HttpConnectionManager_Tracing_OperationName = 1
)

var HttpConnectionManager_Tracing_OperationName_name = map[int32]string{
	0: "INGRESS",
	1: "EGRESS",
}
var HttpConnectionManager_Tracing_OperationName_value = map[string]int32{
	"INGRESS": 0,
	"EGRESS":  1,
}

func (x HttpConnectionManager_Tracing_OperationName) String() string {
	return proto.EnumName(HttpConnectionManager_Tracing_OperationName_name, int32(x))
}
func (HttpConnectionManager_Tracing_OperationName) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor0, []int{0, 0, 0}
}

// [#comment:next free field: 21]
type HttpConnectionManager struct {
	// Supplies the type of codec that the connection manager should use.
	CodecType HttpConnectionManager_CodecType `protobuf:"varint,1,opt,name=codec_type,json=codecType,enum=envoy.config.filter.network.http_connection_manager.v2.HttpConnectionManager_CodecType" json:"codec_type,omitempty"`
	// The human readable prefix to use when emitting statistics for the
	// connection manager. See the :ref:`statistics documentation <config_http_conn_man_stats>` for
	// more information.
	StatPrefix string `protobuf:"bytes,2,opt,name=stat_prefix,json=statPrefix" json:"stat_prefix,omitempty"`
	// Types that are valid to be assigned to RouteSpecifier:
	//	*HttpConnectionManager_Rds
	//	*HttpConnectionManager_RouteConfig
	RouteSpecifier isHttpConnectionManager_RouteSpecifier `protobuf_oneof:"route_specifier"`
	// A list of individual HTTP filters that make up the filter chain for
	// requests made to the connection manager. Order matters as the filters are
	// processed sequentially as request events happen.
	HttpFilters []*HttpFilter `protobuf:"bytes,5,rep,name=http_filters,json=httpFilters" json:"http_filters,omitempty"`
	// Whether the connection manager manipulates the :ref:`config_http_conn_man_headers_user-agent`
	// and :ref:`config_http_conn_man_headers_downstream-service-cluster` headers. See the linked
	// documentation for more information. Defaults to false.
	AddUserAgent *google_protobuf1.BoolValue `protobuf:"bytes,6,opt,name=add_user_agent,json=addUserAgent" json:"add_user_agent,omitempty"`
	// Presence of the object defines whether the connection manager
	// emits :ref:`tracing <arch_overview_tracing>` data to the :ref:`configured tracing provider
	// <envoy_api_msg_config.trace.v2.Tracing>`.
	Tracing *HttpConnectionManager_Tracing `protobuf:"bytes,7,opt,name=tracing" json:"tracing,omitempty"`
	// Additional HTTP/1 settings that are passed to the HTTP/1 codec.
	HttpProtocolOptions *envoy_api_v2_core3.Http1ProtocolOptions `protobuf:"bytes,8,opt,name=http_protocol_options,json=httpProtocolOptions" json:"http_protocol_options,omitempty"`
	// Additional HTTP/2 settings that are passed directly to the HTTP/2 codec.
	Http2ProtocolOptions *envoy_api_v2_core3.Http2ProtocolOptions `protobuf:"bytes,9,opt,name=http2_protocol_options,json=http2ProtocolOptions" json:"http2_protocol_options,omitempty"`
	// An optional override that the connection manager will write to the server
	// header in responses. If not set, the default is *envoy*.
	ServerName string `protobuf:"bytes,10,opt,name=server_name,json=serverName" json:"server_name,omitempty"`
	// The idle timeout for connections managed by the connection manager. The
	// idle timeout is defined as the period in which there are no active
	// requests. If not set, there is no idle timeout. When the idle timeout is
	// reached the connection will be closed. If the connection is an HTTP/2
	// connection a drain sequence will occur prior to closing the connection. See
	// :ref:`drain_timeout
	// <envoy_api_field_config.filter.network.http_connection_manager.v2.HttpConnectionManager.drain_timeout>`.
	IdleTimeout *google_protobuf3.Duration `protobuf:"bytes,11,opt,name=idle_timeout,json=idleTimeout" json:"idle_timeout,omitempty"`
	// The time that Envoy will wait between sending an HTTP/2 “shutdown
	// notification” (GOAWAY frame with max stream ID) and a final GOAWAY frame.
	// This is used so that Envoy provides a grace period for new streams that
	// race with the final GOAWAY frame. During this grace period, Envoy will
	// continue to accept new streams. After the grace period, a final GOAWAY
	// frame is sent and Envoy will start refusing new streams. Draining occurs
	// both when a connection hits the idle timeout or during general server
	// draining. The default grace period is 5000 milliseconds (5 seconds) if this
	// option is not specified.
	DrainTimeout *google_protobuf3.Duration `protobuf:"bytes,12,opt,name=drain_timeout,json=drainTimeout" json:"drain_timeout,omitempty"`
	// Configuration for :ref:`HTTP access logs <arch_overview_access_logs>`
	// emitted by the connection manager.
	AccessLog []*envoy_config_filter_accesslog_v2.AccessLog `protobuf:"bytes,13,rep,name=access_log,json=accessLog" json:"access_log,omitempty"`
	// If set to true, the connection manager will use the real remote address
	// of the client connection when determining internal versus external origin and manipulating
	// various headers. If set to false or absent, the connection manager will use the
	// :ref:`config_http_conn_man_headers_x-forwarded-for` HTTP header. See the documentation for
	// :ref:`config_http_conn_man_headers_x-forwarded-for`,
	// :ref:`config_http_conn_man_headers_x-envoy-internal`, and
	// :ref:`config_http_conn_man_headers_x-envoy-external-address` for more information.
	UseRemoteAddress *google_protobuf1.BoolValue `protobuf:"bytes,14,opt,name=use_remote_address,json=useRemoteAddress" json:"use_remote_address,omitempty"`
	// The number of additional ingress proxy hops from the right side of the
	// :ref:`config_http_conn_man_headers_x-forwarded-for` HTTP header to trust when
	// determining the origin client's IP address. The default is zero if this option
	// is not specified. See the documentation for
	// :ref:`config_http_conn_man_headers_x-forwarded-for` for more information.
	XffNumTrustedHops uint32 `protobuf:"varint,19,opt,name=xff_num_trusted_hops,json=xffNumTrustedHops" json:"xff_num_trusted_hops,omitempty"`
	// of the client connection as the origin client address if *use_remote_address* is true
	// Whether the connection manager will generate the :ref:`x-request-id
	// <config_http_conn_man_headers_x-request-id>` header if it does not exist. This defaults to
	// true. Generating a random UUID4 is expensive so in high throughput scenarios where this feature
	// is not desired it can be disabled.
	GenerateRequestId *google_protobuf1.BoolValue `protobuf:"bytes,15,opt,name=generate_request_id,json=generateRequestId" json:"generate_request_id,omitempty"`
	// How to handle the :ref:`config_http_conn_man_headers_x-forwarded-client-cert` (XFCC) HTTP
	// header.
	ForwardClientCertDetails HttpConnectionManager_ForwardClientCertDetails `protobuf:"varint,16,opt,name=forward_client_cert_details,json=forwardClientCertDetails,enum=envoy.config.filter.network.http_connection_manager.v2.HttpConnectionManager_ForwardClientCertDetails" json:"forward_client_cert_details,omitempty"`
	// This field is valid only when :ref:`forward_client_cert_details
	// <envoy_api_field_config.filter.network.http_connection_manager.v2.HttpConnectionManager.forward_client_cert_details>`
	// is APPEND_FORWARD or SANITIZE_SET and the client connection is mTLS. It specifies the fields in
	// the client certificate to be forwarded. Note that in the
	// :ref:`config_http_conn_man_headers_x-forwarded-client-cert` header, *Hash* is always set, and
	// *By* is always set when the client certificate presents the SAN value.
	SetCurrentClientCertDetails *HttpConnectionManager_SetCurrentClientCertDetails `protobuf:"bytes,17,opt,name=set_current_client_cert_details,json=setCurrentClientCertDetails" json:"set_current_client_cert_details,omitempty"`
	// If proxy_100_continue is true, Envoy will proxy incoming "Expect:
	// 100-continue" headers upstream, and forward "100 Continue" responses
	// downstream. If this is false or not set, Envoy will instead strip the
	// "Expect: 100-continue" header, and send a "100 Continue" response itself.
	Proxy_100Continue bool `protobuf:"varint,18,opt,name=proxy_100_continue,json=proxy100Continue" json:"proxy_100_continue,omitempty"`
	// If
	// :ref:`use_remote_address
	// <envoy_api_field_config.filter.network.http_connection_manager.v2.HttpConnectionManager.use_remote_address>`
	// is true and represent_ipv4_remote_address_as_ipv4_mapped_ipv6 is true and the remote address is
	// an IPv4 address, the address will be mapped to IPv6 before it is appended to *x-forwarded-for*.
	// This is useful for testing compatibility of upstream services that parse the header value. For
	// example, 50.0.0.1 is represented as ::FFFF:50.0.0.1. See `IPv4-Mapped IPv6 Addresses
	// <https://tools.ietf.org/html/rfc4291#section-2.5.5.2>`_ for details. This will also affect the
	// :ref:`config_http_conn_man_headers_x-envoy-external-address` header. See
	// :ref:`http_connection_manager.represent_ipv4_remote_address_as_ipv4_mapped_ipv6
	// <config_http_conn_man_runtime_represent_ipv4_remote_address_as_ipv4_mapped_ipv6>` for runtime
	// control.
	RepresentIpv4RemoteAddressAsIpv4MappedIpv6 bool `protobuf:"varint,20,opt,name=represent_ipv4_remote_address_as_ipv4_mapped_ipv6,json=representIpv4RemoteAddressAsIpv4MappedIpv6" json:"represent_ipv4_remote_address_as_ipv4_mapped_ipv6,omitempty"`
}

func (m *HttpConnectionManager) Reset()                    { *m = HttpConnectionManager{} }
func (m *HttpConnectionManager) String() string            { return proto.CompactTextString(m) }
func (*HttpConnectionManager) ProtoMessage()               {}
func (*HttpConnectionManager) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

type isHttpConnectionManager_RouteSpecifier interface {
	isHttpConnectionManager_RouteSpecifier()
}

type HttpConnectionManager_Rds struct {
	Rds *Rds `protobuf:"bytes,3,opt,name=rds,oneof"`
}
type HttpConnectionManager_RouteConfig struct {
	RouteConfig *envoy_api_v21.RouteConfiguration `protobuf:"bytes,4,opt,name=route_config,json=routeConfig,oneof"`
}

func (*HttpConnectionManager_Rds) isHttpConnectionManager_RouteSpecifier()         {}
func (*HttpConnectionManager_RouteConfig) isHttpConnectionManager_RouteSpecifier() {}

func (m *HttpConnectionManager) GetRouteSpecifier() isHttpConnectionManager_RouteSpecifier {
	if m != nil {
		return m.RouteSpecifier
	}
	return nil
}

func (m *HttpConnectionManager) GetCodecType() HttpConnectionManager_CodecType {
	if m != nil {
		return m.CodecType
	}
	return HttpConnectionManager_AUTO
}

func (m *HttpConnectionManager) GetStatPrefix() string {
	if m != nil {
		return m.StatPrefix
	}
	return ""
}

func (m *HttpConnectionManager) GetRds() *Rds {
	if x, ok := m.GetRouteSpecifier().(*HttpConnectionManager_Rds); ok {
		return x.Rds
	}
	return nil
}

func (m *HttpConnectionManager) GetRouteConfig() *envoy_api_v21.RouteConfiguration {
	if x, ok := m.GetRouteSpecifier().(*HttpConnectionManager_RouteConfig); ok {
		return x.RouteConfig
	}
	return nil
}

func (m *HttpConnectionManager) GetHttpFilters() []*HttpFilter {
	if m != nil {
		return m.HttpFilters
	}
	return nil
}

func (m *HttpConnectionManager) GetAddUserAgent() *google_protobuf1.BoolValue {
	if m != nil {
		return m.AddUserAgent
	}
	return nil
}

func (m *HttpConnectionManager) GetTracing() *HttpConnectionManager_Tracing {
	if m != nil {
		return m.Tracing
	}
	return nil
}

func (m *HttpConnectionManager) GetHttpProtocolOptions() *envoy_api_v2_core3.Http1ProtocolOptions {
	if m != nil {
		return m.HttpProtocolOptions
	}
	return nil
}

func (m *HttpConnectionManager) GetHttp2ProtocolOptions() *envoy_api_v2_core3.Http2ProtocolOptions {
	if m != nil {
		return m.Http2ProtocolOptions
	}
	return nil
}

func (m *HttpConnectionManager) GetServerName() string {
	if m != nil {
		return m.ServerName
	}
	return ""
}

func (m *HttpConnectionManager) GetIdleTimeout() *google_protobuf3.Duration {
	if m != nil {
		return m.IdleTimeout
	}
	return nil
}

func (m *HttpConnectionManager) GetDrainTimeout() *google_protobuf3.Duration {
	if m != nil {
		return m.DrainTimeout
	}
	return nil
}

func (m *HttpConnectionManager) GetAccessLog() []*envoy_config_filter_accesslog_v2.AccessLog {
	if m != nil {
		return m.AccessLog
	}
	return nil
}

func (m *HttpConnectionManager) GetUseRemoteAddress() *google_protobuf1.BoolValue {
	if m != nil {
		return m.UseRemoteAddress
	}
	return nil
}

func (m *HttpConnectionManager) GetXffNumTrustedHops() uint32 {
	if m != nil {
		return m.XffNumTrustedHops
	}
	return 0
}

func (m *HttpConnectionManager) GetGenerateRequestId() *google_protobuf1.BoolValue {
	if m != nil {
		return m.GenerateRequestId
	}
	return nil
}

func (m *HttpConnectionManager) GetForwardClientCertDetails() HttpConnectionManager_ForwardClientCertDetails {
	if m != nil {
		return m.ForwardClientCertDetails
	}
	return HttpConnectionManager_SANITIZE
}

func (m *HttpConnectionManager) GetSetCurrentClientCertDetails() *HttpConnectionManager_SetCurrentClientCertDetails {
	if m != nil {
		return m.SetCurrentClientCertDetails
	}
	return nil
}

func (m *HttpConnectionManager) GetProxy_100Continue() bool {
	if m != nil {
		return m.Proxy_100Continue
	}
	return false
}

func (m *HttpConnectionManager) GetRepresentIpv4RemoteAddressAsIpv4MappedIpv6() bool {
	if m != nil {
		return m.RepresentIpv4RemoteAddressAsIpv4MappedIpv6
	}
	return false
}

// XXX_OneofFuncs is for the internal use of the proto package.
func (*HttpConnectionManager) XXX_OneofFuncs() (func(msg proto.Message, b *proto.Buffer) error, func(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error), func(msg proto.Message) (n int), []interface{}) {
	return _HttpConnectionManager_OneofMarshaler, _HttpConnectionManager_OneofUnmarshaler, _HttpConnectionManager_OneofSizer, []interface{}{
		(*HttpConnectionManager_Rds)(nil),
		(*HttpConnectionManager_RouteConfig)(nil),
	}
}

func _HttpConnectionManager_OneofMarshaler(msg proto.Message, b *proto.Buffer) error {
	m := msg.(*HttpConnectionManager)
	// route_specifier
	switch x := m.RouteSpecifier.(type) {
	case *HttpConnectionManager_Rds:
		b.EncodeVarint(3<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.Rds); err != nil {
			return err
		}
	case *HttpConnectionManager_RouteConfig:
		b.EncodeVarint(4<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.RouteConfig); err != nil {
			return err
		}
	case nil:
	default:
		return fmt.Errorf("HttpConnectionManager.RouteSpecifier has unexpected type %T", x)
	}
	return nil
}

func _HttpConnectionManager_OneofUnmarshaler(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error) {
	m := msg.(*HttpConnectionManager)
	switch tag {
	case 3: // route_specifier.rds
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(Rds)
		err := b.DecodeMessage(msg)
		m.RouteSpecifier = &HttpConnectionManager_Rds{msg}
		return true, err
	case 4: // route_specifier.route_config
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(envoy_api_v21.RouteConfiguration)
		err := b.DecodeMessage(msg)
		m.RouteSpecifier = &HttpConnectionManager_RouteConfig{msg}
		return true, err
	default:
		return false, nil
	}
}

func _HttpConnectionManager_OneofSizer(msg proto.Message) (n int) {
	m := msg.(*HttpConnectionManager)
	// route_specifier
	switch x := m.RouteSpecifier.(type) {
	case *HttpConnectionManager_Rds:
		s := proto.Size(x.Rds)
		n += proto.SizeVarint(3<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case *HttpConnectionManager_RouteConfig:
		s := proto.Size(x.RouteConfig)
		n += proto.SizeVarint(4<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case nil:
	default:
		panic(fmt.Sprintf("proto: unexpected type %T in oneof", x))
	}
	return n
}

type HttpConnectionManager_Tracing struct {
	// The span name will be derived from this field.
	OperationName HttpConnectionManager_Tracing_OperationName `protobuf:"varint,1,opt,name=operation_name,json=operationName,enum=envoy.config.filter.network.http_connection_manager.v2.HttpConnectionManager_Tracing_OperationName" json:"operation_name,omitempty"`
	// A list of header names used to create tags for the active span. The header name is used to
	// populate the tag name, and the header value is used to populate the tag value. The tag is
	// created if the specified header name is present in the request's headers.
	RequestHeadersForTags []string `protobuf:"bytes,2,rep,name=request_headers_for_tags,json=requestHeadersForTags" json:"request_headers_for_tags,omitempty"`
	// Target percentage of requests managed by this HTTP connection manager that will be force
	// traced if the :ref:`x-client-trace-id <config_http_conn_man_headers_x-client-trace-id>`
	// header is set. This field is a direct analog for the runtime variable
	// 'tracing.client_sampling' in the :ref:`HTTP Connection Manager
	// <config_http_conn_man_runtime>`.
	// Default: 100%
	ClientSampling *envoy_type1.Percent `protobuf:"bytes,3,opt,name=client_sampling,json=clientSampling" json:"client_sampling,omitempty"`
	// Target percentage of requests managed by this HTTP connection manager that will be randomly
	// selected for trace generation, if not requested by the client or not forced. This field is
	// a direct analog for the runtime variable 'tracing.random_sampling' in the
	// :ref:`HTTP Connection Manager <config_http_conn_man_runtime>`.
	// Default: 100%
	RandomSampling *envoy_type1.Percent `protobuf:"bytes,4,opt,name=random_sampling,json=randomSampling" json:"random_sampling,omitempty"`
	// Target percentage of requests managed by this HTTP connection manager that will be traced
	// after all other sampling checks have been applied (client-directed, force tracing, random
	// sampling). This field functions as an upper limit on the total configured sampling rate. For
	// instance, setting client_sampling to 100% but overall_sampling to 1% will result in only 1%
	// of client requests with the appropriate headers to be force traced. This field is a direct
	// analog for the runtime variable 'tracing.global_enabled' in the
	// :ref:`HTTP Connection Manager <config_http_conn_man_runtime>`.
	// Default: 100%
	OverallSampling *envoy_type1.Percent `protobuf:"bytes,5,opt,name=overall_sampling,json=overallSampling" json:"overall_sampling,omitempty"`
}

func (m *HttpConnectionManager_Tracing) Reset()         { *m = HttpConnectionManager_Tracing{} }
func (m *HttpConnectionManager_Tracing) String() string { return proto.CompactTextString(m) }
func (*HttpConnectionManager_Tracing) ProtoMessage()    {}
func (*HttpConnectionManager_Tracing) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{0, 0}
}

func (m *HttpConnectionManager_Tracing) GetOperationName() HttpConnectionManager_Tracing_OperationName {
	if m != nil {
		return m.OperationName
	}
	return HttpConnectionManager_Tracing_INGRESS
}

func (m *HttpConnectionManager_Tracing) GetRequestHeadersForTags() []string {
	if m != nil {
		return m.RequestHeadersForTags
	}
	return nil
}

func (m *HttpConnectionManager_Tracing) GetClientSampling() *envoy_type1.Percent {
	if m != nil {
		return m.ClientSampling
	}
	return nil
}

func (m *HttpConnectionManager_Tracing) GetRandomSampling() *envoy_type1.Percent {
	if m != nil {
		return m.RandomSampling
	}
	return nil
}

func (m *HttpConnectionManager_Tracing) GetOverallSampling() *envoy_type1.Percent {
	if m != nil {
		return m.OverallSampling
	}
	return nil
}

type HttpConnectionManager_SetCurrentClientCertDetails struct {
	// Whether to forward the subject of the client cert. Defaults to false.
	Subject *google_protobuf1.BoolValue `protobuf:"bytes,1,opt,name=subject" json:"subject,omitempty"`
	// Whether to forward the SAN of the client cert. Defaults to false.
	San *google_protobuf1.BoolValue `protobuf:"bytes,2,opt,name=san" json:"san,omitempty"`
	// Whether to forward the entire client cert in URL encoded PEM format. This will appear in the
	// XFCC header comma separated from other values with the value Cert="PEM".
	// Defaults to false.
	Cert bool `protobuf:"varint,3,opt,name=cert" json:"cert,omitempty"`
}

func (m *HttpConnectionManager_SetCurrentClientCertDetails) Reset() {
	*m = HttpConnectionManager_SetCurrentClientCertDetails{}
}
func (m *HttpConnectionManager_SetCurrentClientCertDetails) String() string {
	return proto.CompactTextString(m)
}
func (*HttpConnectionManager_SetCurrentClientCertDetails) ProtoMessage() {}
func (*HttpConnectionManager_SetCurrentClientCertDetails) Descriptor() ([]byte, []int) {
	return fileDescriptor0, []int{0, 1}
}

func (m *HttpConnectionManager_SetCurrentClientCertDetails) GetSubject() *google_protobuf1.BoolValue {
	if m != nil {
		return m.Subject
	}
	return nil
}

func (m *HttpConnectionManager_SetCurrentClientCertDetails) GetSan() *google_protobuf1.BoolValue {
	if m != nil {
		return m.San
	}
	return nil
}

func (m *HttpConnectionManager_SetCurrentClientCertDetails) GetCert() bool {
	if m != nil {
		return m.Cert
	}
	return false
}

type Rds struct {
	// Configuration source specifier for RDS.
	ConfigSource *envoy_api_v2_core2.ConfigSource `protobuf:"bytes,1,opt,name=config_source,json=configSource" json:"config_source,omitempty"`
	// The name of the route configuration. This name will be passed to the RDS
	// API. This allows an Envoy configuration with multiple HTTP listeners (and
	// associated HTTP connection manager filters) to use different route
	// configurations.
	RouteConfigName string `protobuf:"bytes,2,opt,name=route_config_name,json=routeConfigName" json:"route_config_name,omitempty"`
}

func (m *Rds) Reset()                    { *m = Rds{} }
func (m *Rds) String() string            { return proto.CompactTextString(m) }
func (*Rds) ProtoMessage()               {}
func (*Rds) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *Rds) GetConfigSource() *envoy_api_v2_core2.ConfigSource {
	if m != nil {
		return m.ConfigSource
	}
	return nil
}

func (m *Rds) GetRouteConfigName() string {
	if m != nil {
		return m.RouteConfigName
	}
	return ""
}

type HttpFilter struct {
	// The name of the filter to instantiate. The name must match a supported
	// filter. The built-in filters are:
	//
	// [#comment:TODO(mattklein123): Auto generate the following list]
	// * :ref:`envoy.buffer <config_http_filters_buffer>`
	// * :ref:`envoy.cors <config_http_filters_cors>`
	// * :ref:`envoy.fault <config_http_filters_fault_injection>`
	// * :ref:`envoy.gzip <config_http_filters_gzip>`
	// * :ref:`envoy.http_dynamo_filter <config_http_filters_dynamo>`
	// * :ref:`envoy.grpc_http1_bridge <config_http_filters_grpc_bridge>`
	// * :ref:`envoy.grpc_json_transcoder <config_http_filters_grpc_json_transcoder>`
	// * :ref:`envoy.grpc_web <config_http_filters_grpc_web>`
	// * :ref:`envoy.health_check <config_http_filters_health_check>`
	// * :ref:`envoy.ip_tagging <config_http_filters_ip_tagging>`
	// * :ref:`envoy.lua <config_http_filters_lua>`
	// * :ref:`envoy.rate_limit <config_http_filters_rate_limit>`
	// * :ref:`envoy.router <config_http_filters_router>`
	// * :ref:`envoy.squash <config_http_filters_squash>`
	Name string `protobuf:"bytes,1,opt,name=name" json:"name,omitempty"`
	// Filter specific configuration which depends on the filter being
	// instantiated. See the supported filters for further documentation.
	Config *google_protobuf.Struct `protobuf:"bytes,2,opt,name=config" json:"config,omitempty"`
	// [#not-implemented-hide:]
	// This is hidden as type has been deprecated and is no longer required.
	DeprecatedV1 *HttpFilter_DeprecatedV1 `protobuf:"bytes,3,opt,name=deprecated_v1,json=deprecatedV1" json:"deprecated_v1,omitempty"`
}

func (m *HttpFilter) Reset()                    { *m = HttpFilter{} }
func (m *HttpFilter) String() string            { return proto.CompactTextString(m) }
func (*HttpFilter) ProtoMessage()               {}
func (*HttpFilter) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *HttpFilter) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *HttpFilter) GetConfig() *google_protobuf.Struct {
	if m != nil {
		return m.Config
	}
	return nil
}

func (m *HttpFilter) GetDeprecatedV1() *HttpFilter_DeprecatedV1 {
	if m != nil {
		return m.DeprecatedV1
	}
	return nil
}

// [#not-implemented-hide:]
// This is hidden as type has been deprecated and is no longer required.
type HttpFilter_DeprecatedV1 struct {
	Type string `protobuf:"bytes,1,opt,name=type" json:"type,omitempty"`
}

func (m *HttpFilter_DeprecatedV1) Reset()                    { *m = HttpFilter_DeprecatedV1{} }
func (m *HttpFilter_DeprecatedV1) String() string            { return proto.CompactTextString(m) }
func (*HttpFilter_DeprecatedV1) ProtoMessage()               {}
func (*HttpFilter_DeprecatedV1) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2, 0} }

func (m *HttpFilter_DeprecatedV1) GetType() string {
	if m != nil {
		return m.Type
	}
	return ""
}

func init() {
	proto.RegisterType((*HttpConnectionManager)(nil), "envoy.config.filter.network.http_connection_manager.v2.HttpConnectionManager")
	proto.RegisterType((*HttpConnectionManager_Tracing)(nil), "envoy.config.filter.network.http_connection_manager.v2.HttpConnectionManager.Tracing")
	proto.RegisterType((*HttpConnectionManager_SetCurrentClientCertDetails)(nil), "envoy.config.filter.network.http_connection_manager.v2.HttpConnectionManager.SetCurrentClientCertDetails")
	proto.RegisterType((*Rds)(nil), "envoy.config.filter.network.http_connection_manager.v2.Rds")
	proto.RegisterType((*HttpFilter)(nil), "envoy.config.filter.network.http_connection_manager.v2.HttpFilter")
	proto.RegisterType((*HttpFilter_DeprecatedV1)(nil), "envoy.config.filter.network.http_connection_manager.v2.HttpFilter.DeprecatedV1")
	proto.RegisterEnum("envoy.config.filter.network.http_connection_manager.v2.HttpConnectionManager_CodecType", HttpConnectionManager_CodecType_name, HttpConnectionManager_CodecType_value)
	proto.RegisterEnum("envoy.config.filter.network.http_connection_manager.v2.HttpConnectionManager_ForwardClientCertDetails", HttpConnectionManager_ForwardClientCertDetails_name, HttpConnectionManager_ForwardClientCertDetails_value)
	proto.RegisterEnum("envoy.config.filter.network.http_connection_manager.v2.HttpConnectionManager_Tracing_OperationName", HttpConnectionManager_Tracing_OperationName_name, HttpConnectionManager_Tracing_OperationName_value)
}

func init() {
	proto.RegisterFile("envoy/config/filter/network/http_connection_manager/v2/http_connection_manager.proto", fileDescriptor0)
}

var fileDescriptor0 = []byte{
	// 1385 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb4, 0x56, 0x4f, 0x6f, 0x1b, 0x45,
	0x14, 0xcf, 0xda, 0xce, 0x1f, 0x3f, 0x3b, 0x89, 0x33, 0x49, 0xdb, 0x25, 0x85, 0xc6, 0x8a, 0x84,
	0x88, 0x4a, 0xb5, 0x8e, 0x4d, 0x29, 0x07, 0x10, 0xc2, 0xce, 0x1f, 0x92, 0xaa, 0x4d, 0xa2, 0xb5,
	0xdb, 0xaa, 0x45, 0x68, 0x34, 0xdd, 0x1d, 0x3b, 0x0b, 0xeb, 0x9d, 0x65, 0x66, 0xd6, 0x4d, 0x4e,
	0x48, 0x3d, 0x21, 0x8e, 0x48, 0x20, 0x6e, 0x1c, 0xf8, 0x00, 0x88, 0x1b, 0xe2, 0xd4, 0x1b, 0x7c,
	0x0a, 0x38, 0xf7, 0x2b, 0x70, 0x42, 0x33, 0xb3, 0xeb, 0xc4, 0xf9, 0x57, 0xd4, 0x96, 0xdb, 0xec,
	0x7b, 0xbf, 0xdf, 0xef, 0xbd, 0x9d, 0x79, 0xf3, 0xe6, 0x41, 0x87, 0x46, 0x03, 0x76, 0x58, 0xf3,
	0x58, 0xd4, 0x0d, 0x7a, 0xb5, 0x6e, 0x10, 0x4a, 0xca, 0x6b, 0x11, 0x95, 0x4f, 0x18, 0xff, 0xb2,
	0xb6, 0x2f, 0x65, 0x8c, 0x3d, 0x16, 0x45, 0xd4, 0x93, 0x01, 0x8b, 0x70, 0x9f, 0x44, 0xa4, 0x47,
	0x79, 0x6d, 0xd0, 0x38, 0xcf, 0xe5, 0xc4, 0x9c, 0x49, 0x86, 0x6e, 0x69, 0x55, 0xc7, 0xa8, 0x3a,
	0x46, 0xd5, 0x49, 0x55, 0x9d, 0xf3, 0xa8, 0x83, 0xc6, 0xe2, 0xdb, 0x26, 0x1b, 0x12, 0x07, 0x2a,
	0x86, 0xc7, 0x38, 0x4d, 0x33, 0xc3, 0x82, 0x25, 0xdc, 0xa3, 0x46, 0x7e, 0xb1, 0x7a, 0x1a, 0xa6,
	0x1d, 0x1e, 0x0b, 0x53, 0xc4, 0xe5, 0x11, 0x04, 0xf7, 0x45, 0x6a, 0x5f, 0x3d, 0xeb, 0x77, 0x89,
	0xe7, 0x51, 0x21, 0x42, 0xd6, 0x53, 0xd8, 0xe1, 0x47, 0xca, 0xb0, 0x0d, 0x43, 0x1e, 0xc6, 0xb4,
	0x16, 0x53, 0xee, 0xd1, 0x48, 0xa6, 0x9e, 0x6b, 0x3d, 0xc6, 0x7a, 0x61, 0x1a, 0xfa, 0x71, 0xd2,
	0xad, 0xf9, 0x09, 0x27, 0xea, 0x8f, 0x52, 0xff, 0x9b, 0x27, 0xfd, 0x42, 0xf2, 0xc4, 0x3b, 0x97,
	0xfd, 0x84, 0x93, 0x38, 0xa6, 0x3c, 0xcb, 0xf4, 0xca, 0x80, 0x84, 0x81, 0x4f, 0x24, 0xad, 0x65,
	0x8b, 0xd4, 0xb1, 0xd0, 0x63, 0x3d, 0xa6, 0x97, 0x35, 0xb5, 0x32, 0xd6, 0xe5, 0x9f, 0x16, 0xe0,
	0xd2, 0x96, 0x94, 0xf1, 0xda, 0x70, 0x5f, 0xef, 0x9a, 0x6d, 0x45, 0x4f, 0x2d, 0x00, 0x8f, 0xf9,
	0xd4, 0xc3, 0xea, 0x1f, 0x6c, 0xab, 0x6a, 0xad, 0xcc, 0x34, 0x1e, 0x38, 0x2f, 0x77, 0x42, 0xce,
	0x99, 0x31, 0x9c, 0x35, 0xa5, 0xdf, 0x39, 0x8c, 0x69, 0x0b, 0x7e, 0x7f, 0xfe, 0x2c, 0x3f, 0xfe,
	0xd4, 0xca, 0x55, 0x2c, 0xb7, 0xe8, 0x65, 0x66, 0x74, 0x1d, 0x4a, 0x42, 0x12, 0x89, 0x63, 0x4e,
	0xbb, 0xc1, 0x81, 0x9d, 0xab, 0x5a, 0x2b, 0xc5, 0x56, 0x51, 0x61, 0x0b, 0x3c, 0x57, 0xb5, 0x5c,
	0x50, 0xde, 0x3d, 0xed, 0x44, 0xbb, 0x90, 0xe7, 0xbe, 0xb0, 0xf3, 0x55, 0x6b, 0xa5, 0xd4, 0xf8,
	0xf0, 0x65, 0x13, 0x75, 0x7d, 0xb1, 0x35, 0xe6, 0x2a, 0x25, 0xb4, 0x01, 0x65, 0xce, 0x12, 0x49,
	0xb1, 0x11, 0xb1, 0x0b, 0x5a, 0xb9, 0x9a, 0x2a, 0x93, 0x38, 0xd0, 0x78, 0x85, 0x58, 0xd3, 0x80,
	0xf4, 0x18, 0xb7, 0xc6, 0xdc, 0x12, 0x3f, 0xb2, 0x22, 0x0a, 0x65, 0x1d, 0xcf, 0xe4, 0x20, 0xec,
	0xf1, 0x6a, 0x7e, 0xa5, 0xd4, 0x68, 0xbd, 0xca, 0x4e, 0x6e, 0x6a, 0xb4, 0x5b, 0xda, 0x1f, 0xae,
	0x05, 0xfa, 0x04, 0x66, 0x88, 0xef, 0xe3, 0x44, 0x50, 0x8e, 0x49, 0x8f, 0x46, 0xd2, 0x9e, 0xd0,
	0xf9, 0x2e, 0x3a, 0xa6, 0x62, 0x9c, 0xac, 0x62, 0x9c, 0x16, 0x63, 0xe1, 0x7d, 0x12, 0x26, 0xd4,
	0x2d, 0x13, 0xdf, 0xbf, 0x27, 0x28, 0x6f, 0x2a, 0x3c, 0x62, 0x30, 0x29, 0x39, 0xf1, 0x82, 0xa8,
	0x67, 0x4f, 0x6a, 0xea, 0xbd, 0xd7, 0x7b, 0xda, 0x1d, 0x23, 0xee, 0x66, 0x51, 0xd0, 0x67, 0x70,
	0x49, 0x8b, 0x64, 0x97, 0x10, 0xb3, 0x58, 0xe1, 0x85, 0x3d, 0xa5, 0xc3, 0xbf, 0x33, 0xba, 0xd3,
	0xea, 0xbe, 0x6a, 0xe5, 0xfa, 0x5e, 0x8a, 0xdf, 0x35, 0x70, 0x77, 0x5e, 0xa9, 0x9c, 0x30, 0xa2,
	0xcf, 0xe1, 0xb2, 0x32, 0x37, 0x4e, 0xab, 0x17, 0x2f, 0x54, 0x6f, 0x9c, 0x54, 0x5f, 0xd8, 0x3f,
	0xc3, 0x8a, 0x96, 0xa0, 0x24, 0x28, 0x1f, 0x50, 0x8e, 0x23, 0xd2, 0xa7, 0x36, 0xa8, 0xca, 0x74,
	0xc1, 0x98, 0x76, 0x48, 0x9f, 0xa2, 0x16, 0x94, 0x03, 0x3f, 0xa4, 0x58, 0x06, 0x7d, 0xca, 0x12,
	0x69, 0x97, 0x74, 0xd4, 0x37, 0x4e, 0x9d, 0xc6, 0x7a, 0x5a, 0x36, 0xad, 0xc2, 0x8f, 0x7f, 0x2f,
	0x59, 0x6e, 0x49, 0x91, 0x3a, 0x86, 0x83, 0xd6, 0x61, 0xda, 0xe7, 0x24, 0x88, 0x86, 0x22, 0xe5,
	0xff, 0x26, 0x52, 0xd6, 0xac, 0x4c, 0xe5, 0x36, 0x80, 0xe9, 0x4e, 0x38, 0x64, 0x3d, 0x7b, 0x5a,
	0x97, 0xdf, 0xbb, 0x67, 0x1e, 0xed, 0x51, 0x13, 0x1b, 0x34, 0x9c, 0xa6, 0xfe, 0xb8, 0xc3, 0x7a,
	0x6e, 0x91, 0x64, 0x4b, 0xb4, 0x05, 0x28, 0x11, 0x14, 0x73, 0xda, 0x67, 0x92, 0x62, 0xe2, 0xfb,
	0x9c, 0x0a, 0x61, 0xcf, 0xbc, 0xb0, 0xd2, 0x2a, 0x89, 0xa0, 0xae, 0x26, 0x35, 0x0d, 0x07, 0xd5,
	0x60, 0xe1, 0xa0, 0xdb, 0xc5, 0x51, 0xd2, 0xc7, 0x92, 0x27, 0x42, 0x52, 0x1f, 0xef, 0xb3, 0x58,
	0xd8, 0xf3, 0x55, 0x6b, 0x65, 0xda, 0x9d, 0x3b, 0xe8, 0x76, 0x77, 0x92, 0x7e, 0xc7, 0x78, 0xb6,
	0x58, 0x2c, 0xd0, 0x6d, 0x98, 0xef, 0xd1, 0x88, 0x72, 0x22, 0x55, 0xfc, 0xaf, 0x12, 0x2a, 0x24,
	0x0e, 0x7c, 0x7b, 0xf6, 0x85, 0xb1, 0xe7, 0x32, 0x9a, 0x6b, 0x58, 0xdb, 0x3e, 0xfa, 0xd5, 0x82,
	0xab, 0x5d, 0xc6, 0x9f, 0x10, 0xee, 0x63, 0x2f, 0x0c, 0x68, 0x24, 0xb1, 0x47, 0xb9, 0xc4, 0x3e,
	0x95, 0x24, 0x08, 0x85, 0x5d, 0xd1, 0xdd, 0xae, 0xfb, 0x7a, 0xeb, 0x7f, 0xd3, 0x04, 0x5c, 0xd3,
	0xf1, 0xd6, 0x28, 0x97, 0xeb, 0x26, 0xda, 0x48, 0xf3, 0xb3, 0xbb, 0xe7, 0xa0, 0xd0, 0x2f, 0x16,
	0x2c, 0x09, 0x2a, 0xb1, 0x97, 0x70, 0xae, 0x13, 0x3e, 0x23, 0xef, 0x39, 0xbd, 0x19, 0xc1, 0xeb,
	0xcd, 0xbb, 0x4d, 0xe5, 0x9a, 0x89, 0x79, 0x2a, 0x29, 0xf7, 0xaa, 0x38, 0xdf, 0x89, 0x6e, 0x00,
	0x8a, 0x39, 0x3b, 0x38, 0xc4, 0xf5, 0xd5, 0x55, 0x15, 0x51, 0x06, 0x51, 0x42, 0x6d, 0x54, 0xb5,
	0x56, 0xa6, 0xdc, 0x8a, 0xf6, 0xd4, 0x57, 0x57, 0xd7, 0x52, 0x3b, 0xa2, 0x50, 0xe7, 0x34, 0xe6,
	0x54, 0xa8, 0xbf, 0x0a, 0xe2, 0xc1, 0xcd, 0x13, 0x55, 0x86, 0x89, 0x30, 0xe6, 0xbe, 0x7a, 0xf0,
	0x7c, 0xb5, 0xbe, 0x65, 0x2f, 0x68, 0xb1, 0xeb, 0x43, 0xe2, 0x76, 0x3c, 0xb8, 0x39, 0x52, 0x67,
	0x4d, 0xa1, 0x4c, 0x77, 0x35, 0x65, 0x3b, 0x1e, 0xdc, 0x5a, 0xfc, 0x23, 0x0f, 0x93, 0x69, 0x27,
	0x42, 0x3f, 0x58, 0x30, 0xc3, 0x62, 0x6a, 0xee, 0x8e, 0xb9, 0xc8, 0xe6, 0x9d, 0xf3, 0xfe, 0x97,
	0xce, 0xe7, 0xec, 0x66, 0xb1, 0x54, 0x87, 0x18, 0x39, 0xf6, 0x69, 0x76, 0xdc, 0x85, 0x3e, 0x00,
	0x3b, 0x2b, 0xf1, 0x7d, 0x4a, 0x7c, 0xca, 0x05, 0xee, 0x32, 0x8e, 0x25, 0xe9, 0x09, 0x3b, 0x57,
	0xcd, 0xaf, 0x14, 0xdd, 0x4b, 0xa9, 0x7f, 0xcb, 0xb8, 0x37, 0x19, 0xef, 0x90, 0x9e, 0x40, 0x1f,
	0xc1, 0x6c, 0x5a, 0x17, 0x82, 0xf4, 0xe3, 0x50, 0xf5, 0x72, 0xf3, 0x20, 0xce, 0xa7, 0x7f, 0xa4,
	0x1e, 0x73, 0x67, 0xcf, 0x0c, 0x24, 0xee, 0x8c, 0xc1, 0xb6, 0x53, 0xa8, 0x62, 0x73, 0x12, 0xf9,
	0xac, 0x7f, 0xc4, 0x2e, 0x5c, 0xc0, 0x36, 0xd8, 0x21, 0xfb, 0x63, 0xa8, 0xb0, 0x01, 0xe5, 0x24,
	0x0c, 0x8f, 0xe8, 0xe3, 0xe7, 0xd3, 0x67, 0x53, 0x70, 0xc6, 0x5f, 0x76, 0x60, 0x7a, 0x64, 0x83,
	0x50, 0x09, 0x26, 0xb7, 0x77, 0x3e, 0x75, 0x37, 0xda, 0xed, 0xca, 0x18, 0x02, 0x98, 0xd8, 0x30,
	0x6b, 0x6b, 0xb1, 0xf0, 0xcd, 0xcf, 0xd7, 0xc6, 0x16, 0xbf, 0xb7, 0xe0, 0xea, 0x05, 0xb5, 0x89,
	0x6e, 0xc2, 0xa4, 0x48, 0x1e, 0x7f, 0x41, 0x3d, 0xa9, 0x4f, 0xf5, 0xe2, 0x26, 0x91, 0x41, 0xd1,
	0x0d, 0xc8, 0x0b, 0x12, 0xe9, 0x51, 0xe3, 0x62, 0x86, 0x82, 0x21, 0x04, 0x05, 0x75, 0x01, 0xf5,
	0x26, 0x4f, 0xb9, 0x7a, 0xbd, 0x5c, 0x87, 0xe2, 0x70, 0xb0, 0x41, 0x53, 0x50, 0x68, 0xde, 0xeb,
	0xec, 0x56, 0xc6, 0x50, 0x11, 0xc6, 0xb7, 0x3a, 0x9d, 0xbd, 0x7a, 0xc5, 0xca, 0x96, 0x8d, 0x4a,
	0xce, 0xfc, 0xca, 0xf2, 0xd7, 0x60, 0x9f, 0xd7, 0x1d, 0x50, 0x19, 0xa6, 0xda, 0xcd, 0x9d, 0xed,
	0xce, 0xf6, 0xa3, 0x8d, 0xca, 0x18, 0xaa, 0x40, 0x79, 0x73, 0xd7, 0x7d, 0xd0, 0x74, 0xd7, 0xf1,
	0xee, 0xce, 0x9d, 0x87, 0x15, 0x0b, 0x21, 0x98, 0x69, 0xee, 0xed, 0x6d, 0xec, 0xac, 0xe3, 0xd4,
	0x51, 0xc9, 0x29, 0x54, 0xc6, 0xc1, 0xed, 0x8d, 0x4e, 0x25, 0x8f, 0xae, 0xc0, 0x7c, 0xf3, 0xce,
	0x83, 0xe6, 0xc3, 0x36, 0x1e, 0xa1, 0x17, 0x4c, 0x02, 0x2d, 0x1b, 0x66, 0xcd, 0xac, 0x23, 0x62,
	0xea, 0x05, 0xdd, 0x80, 0x72, 0x34, 0xfe, 0xdb, 0xf3, 0x67, 0x79, 0x6b, 0xf9, 0x3b, 0x0b, 0xf2,
	0xae, 0x2f, 0x50, 0x07, 0xa6, 0x47, 0x66, 0xea, 0x74, 0x4f, 0x97, 0xce, 0x78, 0x46, 0xcd, 0xe0,
	0xd3, 0xd6, 0xb0, 0xd6, 0xcc, 0x9f, 0x7f, 0x2d, 0x8d, 0xe9, 0x4a, 0xff, 0x56, 0x57, 0x7a, 0xd9,
	0x3b, 0xe6, 0x45, 0xef, 0xc3, 0xdc, 0xf1, 0x19, 0xcb, 0xdc, 0xc1, 0x53, 0x63, 0xde, 0xec, 0xb1,
	0x79, 0x4a, 0x55, 0xc6, 0xf2, 0x3f, 0x16, 0xc0, 0xd1, 0x20, 0x84, 0xde, 0x82, 0xc2, 0xf0, 0xf2,
	0x8e, 0x10, 0xb5, 0x19, 0xd5, 0x60, 0x22, 0x1d, 0xe1, 0xcc, 0xa9, 0x5e, 0x39, 0x75, 0xaa, 0x6d,
	0x3d, 0x62, 0xbb, 0x29, 0x0c, 0x1d, 0xc0, 0xb4, 0xaf, 0x3a, 0x8a, 0x47, 0xd4, 0xb3, 0x34, 0xa8,
	0xa7, 0x77, 0x68, 0xf7, 0xd5, 0x67, 0x36, 0x67, 0x7d, 0xa8, 0x7b, 0xbf, 0xde, 0xca, 0xd9, 0xea,
	0xad, 0x3e, 0x66, 0x59, 0x5c, 0x86, 0xf2, 0x71, 0x84, 0xaa, 0xaf, 0xe1, 0xf8, 0x5d, 0x74, 0xf5,
	0xba, 0x55, 0x78, 0x94, 0x1b, 0x34, 0x1e, 0x4f, 0xe8, 0xe4, 0xdf, 0xfb, 0x37, 0x00, 0x00, 0xff,
	0xff, 0xef, 0x8a, 0xf1, 0xd8, 0x8a, 0x0d, 0x00, 0x00,
}
