// Code generated by protoc-gen-go. DO NOT EDIT.
// source: envoy/service/auth/v2/external_auth.proto

package v2

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import google_rpc "google.golang.org/genproto/googleapis/rpc/status"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

type CheckRequest struct {
	// The request attributes.
	Attributes *AttributeContext `protobuf:"bytes,1,opt,name=attributes" json:"attributes,omitempty"`
}

func (m *CheckRequest) Reset()                    { *m = CheckRequest{} }
func (m *CheckRequest) String() string            { return proto.CompactTextString(m) }
func (*CheckRequest) ProtoMessage()               {}
func (*CheckRequest) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{0} }

func (m *CheckRequest) GetAttributes() *AttributeContext {
	if m != nil {
		return m.Attributes
	}
	return nil
}

type CheckResponse struct {
	// Status `OK` allows the request. Any other status indicates the request should be denied.
	Status *google_rpc.Status `protobuf:"bytes,1,opt,name=status" json:"status,omitempty"`
}

func (m *CheckResponse) Reset()                    { *m = CheckResponse{} }
func (m *CheckResponse) String() string            { return proto.CompactTextString(m) }
func (*CheckResponse) ProtoMessage()               {}
func (*CheckResponse) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{1} }

func (m *CheckResponse) GetStatus() *google_rpc.Status {
	if m != nil {
		return m.Status
	}
	return nil
}

func init() {
	proto.RegisterType((*CheckRequest)(nil), "envoy.service.auth.v2.CheckRequest")
	proto.RegisterType((*CheckResponse)(nil), "envoy.service.auth.v2.CheckResponse")
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for Authorization service

type AuthorizationClient interface {
	// Performs authorization check based on the attributes associated with the
	// incoming request, and returns status `OK` or not `OK`.
	Check(ctx context.Context, in *CheckRequest, opts ...grpc.CallOption) (*CheckResponse, error)
}

type authorizationClient struct {
	cc *grpc.ClientConn
}

func NewAuthorizationClient(cc *grpc.ClientConn) AuthorizationClient {
	return &authorizationClient{cc}
}

func (c *authorizationClient) Check(ctx context.Context, in *CheckRequest, opts ...grpc.CallOption) (*CheckResponse, error) {
	out := new(CheckResponse)
	err := grpc.Invoke(ctx, "/envoy.service.auth.v2.Authorization/Check", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for Authorization service

type AuthorizationServer interface {
	// Performs authorization check based on the attributes associated with the
	// incoming request, and returns status `OK` or not `OK`.
	Check(context.Context, *CheckRequest) (*CheckResponse, error)
}

func RegisterAuthorizationServer(s *grpc.Server, srv AuthorizationServer) {
	s.RegisterService(&_Authorization_serviceDesc, srv)
}

func _Authorization_Check_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CheckRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AuthorizationServer).Check(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/envoy.service.auth.v2.Authorization/Check",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AuthorizationServer).Check(ctx, req.(*CheckRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _Authorization_serviceDesc = grpc.ServiceDesc{
	ServiceName: "envoy.service.auth.v2.Authorization",
	HandlerType: (*AuthorizationServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Check",
			Handler:    _Authorization_Check_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "envoy/service/auth/v2/external_auth.proto",
}

func init() { proto.RegisterFile("envoy/service/auth/v2/external_auth.proto", fileDescriptor1) }

var fileDescriptor1 = []byte{
	// 245 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x7c, 0x90, 0xcd, 0x4a, 0x03, 0x31,
	0x14, 0x85, 0x19, 0xc1, 0x0a, 0xd1, 0x6e, 0x02, 0xa2, 0xcc, 0x4a, 0xaa, 0xe0, 0x0f, 0x78, 0x03,
	0x71, 0xe9, 0xaa, 0x76, 0xe1, 0x7e, 0x5c, 0x08, 0x6e, 0x4a, 0x1a, 0x2e, 0x9d, 0xc1, 0x92, 0x3b,
	0x26, 0x37, 0xa1, 0xfa, 0x04, 0x3e, 0xb6, 0x98, 0x8c, 0xd2, 0xc5, 0xe8, 0x36, 0xe7, 0xcb, 0x77,
	0x4e, 0x22, 0xae, 0xd1, 0x25, 0x7a, 0x57, 0x01, 0x7d, 0xea, 0x2c, 0x2a, 0x13, 0xb9, 0x55, 0x49,
	0x2b, 0xdc, 0x32, 0x7a, 0x67, 0x36, 0xcb, 0xef, 0x03, 0xe8, 0x3d, 0x31, 0xc9, 0xe3, 0x8c, 0xc2,
	0x80, 0x42, 0x4e, 0x92, 0xae, 0x6f, 0xc7, 0x0d, 0x86, 0xd9, 0x77, 0xab, 0xc8, 0xb8, 0xb4, 0xe4,
	0x18, 0xb7, 0x5c, 0x2c, 0xf5, 0xc9, 0x9a, 0x68, 0xbd, 0x41, 0xe5, 0x7b, 0xab, 0x02, 0x1b, 0x8e,
	0xa1, 0x04, 0xb3, 0x67, 0x71, 0xb4, 0x68, 0xd1, 0xbe, 0x36, 0xf8, 0x16, 0x31, 0xb0, 0x7c, 0x14,
	0xe2, 0xd7, 0x11, 0x4e, 0xab, 0xb3, 0xea, 0xea, 0x50, 0x5f, 0xc2, 0xe8, 0x06, 0x98, 0xff, 0x80,
	0x8b, 0xd2, 0xd5, 0xec, 0x5c, 0x9d, 0xdd, 0x8b, 0xe9, 0x20, 0x0e, 0x3d, 0xb9, 0x80, 0xf2, 0x46,
	0x4c, 0x4a, 0xf3, 0x60, 0x95, 0x50, 0x36, 0x81, 0xef, 0x2d, 0x3c, 0xe5, 0xa4, 0x19, 0x08, 0x6d,
	0xc5, 0x74, 0x1e, 0xb9, 0x25, 0xdf, 0x7d, 0x18, 0xee, 0xc8, 0xc9, 0x46, 0xec, 0x67, 0x9b, 0x3c,
	0xff, 0x63, 0xcb, 0xee, 0x23, 0xea, 0x8b, 0xff, 0xa1, 0x32, 0xe8, 0xe1, 0xe0, 0x65, 0x2f, 0xe9,
	0xcf, 0xaa, 0x5a, 0x4d, 0xf2, 0x57, 0xdc, 0x7d, 0x05, 0x00, 0x00, 0xff, 0xff, 0x95, 0xc9, 0x38,
	0xfb, 0x96, 0x01, 0x00, 0x00,
}
